#include "sa.h"

extern FILE *ptr_adapt, *fptr0;
double prob_func();
double log();
int set= 0;
/*------------------------------------------*/
double compute_maximum_heat()          /* 1 */
{
  double  new_cost = 0.0,  boltz_dist, CT = 0.0, diff_cost = 0.0, current_cost = 0.0;
  static  ind  =  0;
  int j = 0, m = 0, num_config = 0, i, k = 1000000; 

  spec_heat = e_cost = e_cost_square = 0.0;

  ind++;
  srand48(time(NULL));
  srandom(time(NULL));
  for (i = 0; i < current; i++)
    {
      /* Comments:  think of modifying accum_costs[i] before making the
	 addition to e_cost. The modification is as below for the e_cost.  
	 This will result in different costs than the following method. 
      */
      
      new_cost = (double) accum_costs[i];

#if 0
      e_cost -= ((log10(drand48() * sqrt((double) current))/log10(2)) * drand48() * 
		 log10(drand48() *sqrt((double) current))/log10(2) * 
		 drand48() * log10(drand48() * current)/log10(2));
#endif

      /* Pay some attention to the following format ....  */

      /*       printf("====== New Cost = %lf           Previous Cost = %lf\n", new_cost, prev_cost);   */
#if 1
      if ((i > 0) && ((new_cost - prev_cost) > 0.0))
	{
	  diff_cost = new_cost - prev_cost;

	  if (diff_cost < 0.0)
	    diff_cost = diff_cost * (-1.0);
	  current_cost = new_cost;
	  new_cost  -=  
	    10 * log10(drand48() * diff_cost)/log10(2) * 
	    log10(drand48() * current)/log10(2)  * 
	    log10(drand48() * new_cost)/log10(2) *
                    log10(pow((double) ind, (double) 0.5))/log10(2);
	  if (new_cost < 0.0)
	    new_cost  = current_cost;
	}
#endif

      prev_cost = new_cost;
      e_cost += (double) new_cost;
      e_cost_square += (double) (new_cost * new_cost);
    }
 
  e_cost = e_cost / current;
  e_cost_square = e_cost_square / current;

  /*  num_config = (random() % current);   */

  /* see equation 10 of out paper ... */

  num_config = iters_per_timestep;

  variance = (double) (e_cost_square/num_config  - 
		       ((e_cost * e_cost) / (num_config * num_config)));

  spec_heat = (double) (variance / temperature);
  standard_deviation = (double) sqrt((double) variance);

  printf("cost = %lf\n", e_cost);
  printf("variance = %lf\n", variance);
  printf("standard_deviation = %lf\n", standard_deviation);
  printf("specific_heat = %lf\n", spec_heat);
  printf("temperature = %lf\n", temperature); 
  printf("number_of_configurations = %d\n", num_config);
  printf("------------------------------------------- \n");
  fprintf(fptr0,"cost = %lf\n", e_cost);
  fprintf(fptr0,"variance = %lf\n", variance); 
  fprintf(fptr0,"standard_deviation = %lf\n", standard_deviation);
  fprintf(fptr0,"specific_heat = %lf\n", spec_heat);
  fprintf(fptr0,"temperature = %lf\n", temperature); 
  fprintf(fptr0,"number_of_configurations = %d\n", num_config);
  return((double) spec_heat);
}

/*------------------------------------------*/
double Q_sum()                         /* 2 */
{
  int j = 0,  k = 100000;
  double  Q = 0.0,  scaled_cost = 0.0;

#if 1
  for (j = 0; j < current; j++)
    printf("In Q_sum, accum_costs[%d] = %lf\n", j, accum_costs[j]);
#endif

  if (current <= 1)
    Q = (double) (accum_costs[current]/k);
  else
    {
      for (j = 0; j < current; j++)
	{
	  scaled_cost = (double) (accum_costs[j]/k);
	  Q += 
	    (double) pow((double) M_E, (double)(- scaled_cost / temperature));
	}
    }

  if (Q == 0.0)
    return(1.0);
  else
    return(Q);
}

/*-----------------------------------------------*/
double prob_func(int n)                     /* 3 */
{
  double prob = 0.0;
  int k = 100000;
  double scaled_cost = 0.0;
  double q_sum = 0.0;

  scaled_cost = (double) (accum_costs[n] / k);
  q_sum = Q_sum();
  prob = 
    (double) pow((double) M_E, (double) (- scaled_cost /temperature)) / q_sum;

  return((double) prob);
}

/*------------------------------------------*/
double lowest_cost()                   /* 4 */
{
  int i = 0;
  double smallest;
  int k = 100000;

/*--------------
compute lowest cost of accum_costs[0], accum_costs[1], ... ,
 accum_costs[current - 1].
Then return(accum_costs[i]).
---------------*/
  smallest = accum_costs[0];
  for (i = 0; i < current; i++)
    {
      if (accum_costs[i] < smallest)
	{
	  smallest = accum_costs[i];
	}
    }
  return(smallest);
}

/*---------------------------------------------*/
terminate_test()                          /* 5 */
{
  int k;
  double  delta_cost1 = 0.0, delta_cost2 = 0.0;

  for (k = 0; k < current; k++)
    {
      if ((k - 1) > 0)
	delta_cost1 = accum_costs[k - 1] - accum_costs[k - 2];
      if ((k + 1) < current)
	delta_cost2 = accum_costs[k + 1] - accum_costs[k];

#if 1
      if (delta_cost1 > 0.0)
	{
	  if ((delta_cost2 == - delta_cost1) 
	      || (delta_cost2 == - 2.0 * delta_cost1))
	    local_min++;
	}
#endif

      if ((delta_cost1 == 0.0) && (delta_cost2 == 0.0))
	local_min++;
    }
}

/*---------------------------------------------*/
double adapt_P_parameter(double cost)     /* 6 */
{
  return((1.0 / (1.0 + pow((double) M_E, - ((double) cost/10000.0)))));
}

/*---------------------------------------------*/
check_previous_swap2(int current_size)    /* 7 */
 {
   int i, count = 0,  diff1 = 0,  diff2 = 0;

   if (current_size <= 1)
     return(0);
   else
     {
       for (i = 0; i < current_size; i++)
         {
           if ((i - 1) > 0)
             diff1 = swap2_store[i - 1] - swap2_store[i - 2];
           if ((i + 1) < current_size)
             diff2 = swap2_store[i + 1] - swap2_store[i];
           if ((diff1 == 0) && (diff2 == 0))
             count++;
         }
     }
   if (count > 0)
     return(1);
   else
     return(0);
 }

/*--------------------------------------------*/
terminate_test2()                       /*  8 */
 {
   int i;
   double  diff1 = 0.0,  diff2 = 0.0;

   for (i = 0; i < current; i++)
     {
       if ((i - 1) > 0)
	 diff1 = accum_costs[i - 1] - accum_costs[i - 2];
       if ((i + 1) < current)
	 diff2 = accum_costs[i + 1] - accum_costs[i];
       if ((diff1 == 0.0) && (diff2 == 0.0))
	 local_min++;
     }
 }

/*===============================================*/
double peak_specific_heat()                  
{
  int i = 0;
  double peak_value;

  peak_value = specific_heat[0];

  for (i = 0; i < Max_Markov_Chain; i++)
    {
      if (specific_heat[i] > peak_value)
	{
	  peak_value = specific_heat[i];
	}
      if (i > 0)
	{
	  if (specific_heat[i] == 0.0)
	    break;
	}
    }
  return(peak_value);
}

